/* keyword.h */

/* Copyright (C) 2006, 2013 Niels Möller
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef INSTR16_KEYWORD_H
#define INSTR16_KEYWORD_H

enum keyword {
  KEYWORD_INT8,
  KEYWORD_INT16,
  KEYWORD_INT32,
  KEYWORD_INT64,
  KEYWORD_SINGLE,
  KEYWORD_DOUBLE,
  KEYWORD_NOP,
  KEYWORD_LD,
  KEYWORD_ST,
  KEYWORD_MOV,
  KEYWORD_MOVT,
  KEYWORD_MOVF,
  KEYWORD_ADD,
  KEYWORD_ADDC,
  KEYWORD_ADDS,
  KEYWORD_ADDV,
  KEYWORD_SUB,
  KEYWORD_SUBC,
  KEYWORD_SUBS,
  KEYWORD_SUBV,
  KEYWORD_NEG,
  KEYWORD_UMULL,
  KEYWORD_SHIFTL,
  KEYWORD_LSHIFT,
  KEYWORD_RSHIFT,
  KEYWORD_ASHIFT,
  KEYWORD_ROT,
  KEYWORD_AND,
  KEYWORD_OR,
  KEYWORD_XOR,
  KEYWORD_NOT,
  KEYWORD_UMULHI,
  KEYWORD_MULLO,
  KEYWORD_INJT8,
  KEYWORD_INJT16,
  KEYWORD_INJT32,
  KEYWORD_TST,
  KEYWORD_CMPEQ,
  KEYWORD_CMPUGEQ,
  KEYWORD_CMPSGEQ,
  KEYWORD_CMPULT,
  KEYWORD_CMPSLT,
  KEYWORD_CMPUGT,
  KEYWORD_CMPSGT,
  KEYWORD_CLZ,
  KEYWORD_CLT,
  KEYWORD_CLS,
  KEYWORD_POPC,
  KEYWORD_XSHIFT,
  KEYWORD_XSHIFTC,
  KEYWORD_LSHIFTC,
  KEYWORD_ASHIFTC,
  KEYWORD_RECPR,
  KEYWORD_JMP,
  KEYWORD_JSR,
  KEYWORD_BT,
  KEYWORD_BF,
  KEYWORD_BKPT,
  KEYWORD_HALT,
  KEYWORD_CC,
  KEYWORD_R0,
  KEYWORD_R1,
  KEYWORD_R2,
  KEYWORD_R3,
  KEYWORD_R4,
  KEYWORD_R5,
  KEYWORD_R6,
  KEYWORD_R7,
  KEYWORD_R8,
  KEYWORD_R9,
  KEYWORD_R10,
  KEYWORD_R11,
  KEYWORD_R12,
  KEYWORD_R13,
  KEYWORD_R14,
  KEYWORD_R15,
};

struct keyword_assoc
{
  const char *name;
  enum keyword id;
  unsigned type;
  /* Opcode or other flags used for code generation */
  uint16_t code;
  /* Alternative code, e.g., for a different addressing mode. */
  uint16_t alt;
};

const struct keyword_assoc *
keyword_lookup (const char *str, unsigned int len);

#endif /* INSTR16_KEYWORD_H */
